class LeaderBoard {
  String id;
  String name;
  RewardItem rewardItem;

  LeaderBoard.fromJson(Map json)
      : name = json['name'],
        id = json['id'],
        rewardItem = RewardItem.fromJson(json['rewardItem']);

  Map<String, dynamic> toJson() =>
      {'name': name, 'id': id, 'rewardItem': rewardItem.toJson()};
}

class RewardItem {
  String id;
  String name;

  RewardItem.fromJson(Map json)
      : name = json['name'],
        id = json['id'];

  Map<String, dynamic> toJson() => {
        'name': name,
        'id': id,
      };
}

class LeaderBoardEntryResult {
  int count;
  bool hasNext;
  bool hasPrevious;
  List<LeaderBoardEntry> list;

  LeaderBoardEntryResult.fromJson(Map json)
      : count = json['count'],
        hasNext = json['hasNext'],
        hasPrevious = json['hasPrevious'],
        list = json["list"] != null
            ? List.from(json["list"])
                .map((e) => LeaderBoardEntry.fromJson(e))
                .toList()
            : [];
}

class LeaderBoardEntry {
  String? profile_id;
  String? profile_nickname;
  String? percentile_rank;
  double? score;
  int? rank;
  Profile? profile;

  LeaderBoardEntry.fromJson(Map json)
      : profile_id = json['profile_id'],
        profile_nickname = json['profile_nickname'],
        percentile_rank = json['percentile_rank'],
        score = json['score'],
        rank = json['rank'],
        profile = Profile.fromJson(json['profile']);
}

class Profile {
  String? id;
  String? nickname;
  String? custom_data;

  Profile.fromJson(Map json)
      : nickname = json['nickname'],
        id = json['id'],
        custom_data = json['custom_data'];
}

enum LiveLikePagination { first, next, previous }
