import 'dart:convert';

import 'package:livelike_flutter_sdk/src/model/program.dart';

class LiveLikeWidget {
  String? program_id;
  String? created_at;
  String? scheduled_at;
  int? engagement_count;
  String? publish_delay;
  String? rewards_url;
  String? schedule_url;
  String? timeout;
  int? impression_count;
  String? engagement_percent;
  String? program_date_time;
  String? id;
  String? published_at;
  int? unique_impression_count;
  String? question;
  String? kind;
  String? subscribe_channel;
  String? url;
  String? cheer_type;
  String? impression_url;
  String? interaction_url;
  String? custom_data;
  String? text;
  String? status;
  String? image_url;
  String? link_url;
  String? link_label;
  String? text_prediction_id;
  String? image_prediction_id;
  String? text_prediction_url;
  String? image_prediction_url;
  String? correct_option_id;
  String? title;
  String? initial_magnitude;
  String? average_magnitude;
  String? vote_url;
  String? comment;
  List<String>? translatable_fields;
  List<Option>? options;
  List<Option>? choices;
  int? timeout_time;

  bool? show;
  WidgetUserInteraction? widgetUserInteraction;
  double? widget_height;
  String? widget_interactions_url_template;
  List<Sponsors>? sponsors;
  List<LiveLikeWidget>? follow_ups;
  String? follow_up_url;
  String? claim_url;
  String? confirmation_message;
  List<Items>? items;

  LiveLikeWidget(
      {this.program_id,
      this.created_at,
      this.scheduled_at,
      this.engagement_count,
      this.publish_delay,
      this.rewards_url,
      this.schedule_url,
      this.timeout,
      this.impression_count,
      this.engagement_percent,
      this.program_date_time,
      this.id,
      this.published_at,
      this.unique_impression_count,
      this.question,
      this.kind,
      this.subscribe_channel,
      this.url,
      this.cheer_type,
      this.impression_url,
      this.interaction_url,
      this.custom_data,
      this.text,
      this.status,
      this.image_url,
      this.link_url,
      this.link_label,
      this.text_prediction_id,
      this.image_prediction_id,
      this.text_prediction_url,
      this.correct_option_id,
      this.title,
      this.initial_magnitude,
      this.average_magnitude,
      this.vote_url,
      this.sponsors,
      this.comment,
      this.timeout_time,
      this.widgetUserInteraction,
      this.translatable_fields,
      this.options,
      this.widget_height,
      this.follow_ups,
      this.confirmation_message,
      this.claim_url,
      this.follow_up_url,
      this.items,
      this.image_prediction_url,
      this.widget_interactions_url_template,
      this.choices});

  factory LiveLikeWidget.fromJson(Map<dynamic, dynamic> json) {
    return LiveLikeWidget(
        program_id: json["program_id"],
        created_at: json["created_at"],
        scheduled_at: json["scheduled_at"],
        engagement_count: json["engagement_count"],
        publish_delay: json["publish_delay"],
        rewards_url: json["rewards_url"],
        schedule_url: json["schedule_url"],
        timeout: json["timeout"],
        timeout_time: json["timeout_time"],
        impression_count: json["impression_count"],
        engagement_percent: json["engagement_percent"],
        program_date_time: json["program_date_time"],
        id: json["id"],
        published_at: json["published_at"],
        unique_impression_count: json["unique_impression_count"],
        question: json["question"],
        kind: json["kind"],
        subscribe_channel: json["subscribe_channel"],
        url: json["url"],
        cheer_type: json["cheer_type"],
        impression_url: json["impression_url"],
        interaction_url: json["interaction_url"],
        custom_data: json["custom_data"],
        text: json["text"],
        status: json["status"],
        image_url: json["image_url"],
        link_url: json["link_url"],
        link_label: json["link_label"],
        text_prediction_id: json["text_prediction_id"] ?? "",
        image_prediction_id: json["image_prediction_id"] ?? "",
        text_prediction_url: json["text_prediction_url"],
        image_prediction_url: json["image_prediction_url"],
        correct_option_id: json["correct_option_id"] ?? "",
        title: json["title"],
        confirmation_message: json["confirmation_message"],
        initial_magnitude: json["initial_magnitude"],
        average_magnitude: json["average_magnitude"],
        vote_url: json["vote_url"],
        widget_height: json["widget_height"],
        comment: json["comment"],
        items: json["items"] != null
            ? List.of(json["items"]).map((e) => Items.fromJson(e)).toList()
            : null,
        claim_url: json["claim_url"],
        follow_ups: json["follow_ups"] != null
            ? List.of(json["follow_ups"])
                .map((e) => LiveLikeWidget.fromJson(e))
                .toList()
            : null,
        widget_interactions_url_template:
            json["widget_interactions_url_template"],
        translatable_fields: json["translatable_fields"] != null
            ? List.of(json["translatable_fields"])
                .map((i) => i.toString())
                .toList()
            : null,
        options: json["options"] != null
            ? List.of(json["options"]).map((i) => Option.fromJson(i)).toList()
            : null,
        choices: json["choices"] != null
            ? List.of(json["choices"]).map((i) => Option.fromJson(i)).toList()
            : null,
        widgetUserInteraction: json["widgetUserInteraction"] != null
            ? WidgetUserInteraction.fromJson(json["widgetUserInteraction"])
            : null,
        follow_up_url: json["follow_up_url"],
        sponsors: json["sponsors"] != null
            ? List.of(json["sponsors"])
                .map((e) => Sponsors.fromJson(e))
                .toList()
            : null);
  }

  Map<String, dynamic> toJson() {
    return {
      "program_id": this.program_id,
      "created_at": this.created_at,
      "scheduled_at": this.scheduled_at,
      "engagement_count": this.engagement_count,
      "publish_delay": this.publish_delay,
      "rewards_url": this.rewards_url,
      "schedule_url": this.schedule_url,
      "timeout": this.timeout,
      "impression_count": this.impression_count,
      "engagement_percent": this.engagement_percent,
      "program_date_time": this.program_date_time,
      "id": this.id,
      "published_at": this.published_at,
      "unique_impression_count": this.unique_impression_count,
      "question": this.question,
      "kind": this.kind,
      "subscribe_channel": this.subscribe_channel,
      "url": this.url,
      "cheer_type": this.cheer_type,
      "impression_url": this.impression_url,
      "interaction_url": this.interaction_url,
      "custom_data": this.custom_data,
      "text": this.text,
      "status": this.status,
      "image_url": this.image_url,
      "link_url": this.link_url,
      "link_label": this.link_label,
      "text_prediction_id": this.text_prediction_id ?? "",
      "image_prediction_id": this.image_prediction_id ?? "",
      "text_prediction_url": this.text_prediction_url,
      "image_prediction_url": this.image_prediction_url,
      "correct_option_id": this.correct_option_id ?? "",
      "title": this.title,
      "initial_magnitude": this.initial_magnitude,
      "average_magnitude": this.average_magnitude,
      "vote_url": this.vote_url,
      "comment": this.comment,
      "translatable_fields":
          this.translatable_fields?.map((e) => e.toString()).toList(),
      "options": this.options?.map((e) => e.toJson()).toList(),
      "choices": this.choices?.map((e) => e.toJson()).toList(),
      "sponsors": this.sponsors?.map((e) => e.toJson()).toList(),
      "timeout_time": this.timeout_time,
      "show": this.show,
      "claim_url": this.claim_url,
      "widget_interactions_url_template": this.widget_interactions_url_template,
      "follow_ups": this.follow_ups?.map((e) => e.toJson()).toList(),
      "follow_up_url": this.follow_up_url,
      "confirmation_message": this.confirmation_message,
      "items": this.items?.map((e) => e.toJson()).toList(),
    };
  }
}

class Option {
  String? image_url;
  String? vote_url;
  String? id;
  String? description;
  List<String>? translatable_fields;
  int? vote_count;
  bool? is_correct;
  String? answer_url;
  int? answer_count;

  Option(
      {this.image_url,
      this.vote_url,
      this.id,
      this.description,
      this.translatable_fields,
      this.vote_count,
      this.is_correct,
      this.answer_url,
      this.answer_count});

  factory Option.fromJson(Map<dynamic, dynamic> json) {
    return Option(
      image_url: json["image_url"],
      vote_url: json["vote_url"],
      id: json["id"],
      description: json["description"],
      translatable_fields: json["translatable_fields"] != null
          ? List.of(json["translatable_fields"])
              .map((i) => i.toString())
              .toList()
          : null,
      vote_count: json["vote_count"],
      is_correct: json["is_correct"],
      answer_url: json["answer_url"],
      answer_count: json["answer_count"],
    );
  }

  Map<String, dynamic> toJson() {
    return {
      "image_url": this.image_url,
      "vote_url": this.vote_url,
      "id": this.id,
      "description": this.description,
      "translatable_fields": jsonEncode(this.translatable_fields),
      "vote_count": this.vote_count,
      "is_correct": this.is_correct,
      "answer_url": this.answer_url,
      "answer_count": this.answer_count,
    };
  }
}

class WidgetUserInteraction {
  String? id;
  String? created_at;
  String? url;
  String? widget_id;
  String? widget_kind;
  double? magnitude;
  String? choice_id;
  String? option_id;
  bool? is_correct;
  String? claim_token;
  int? vote_count;

  WidgetUserInteraction(
      {this.id,
      this.created_at,
      this.url,
      this.widget_id,
      this.widget_kind,
      this.magnitude,
      this.choice_id,
      this.option_id,
      this.is_correct,
      this.claim_token,
      this.vote_count});

  factory WidgetUserInteraction.fromJson(Map<dynamic, dynamic> json) {
    return WidgetUserInteraction(
        id: json["id"],
        created_at: json["created_at"],
        url: json["url"],
        widget_id: json["widget_id"],
        widget_kind: json["widget_kind"],
        magnitude:
            json["magnitude"] != null ? double.parse(json["magnitude"]) : null,
        choice_id: json["choice_id"],
        option_id: json["option_id"],
        is_correct: json["is_correct"],
        claim_token: json["claim_token"],
        vote_count: json["vote_count"]);
  }

  Map<String, dynamic> toJson() {
    return {
      "id": this.id,
      "created_at": this.created_at,
      "url": this.url,
      "widget_id": this.widget_id,
      "widget_kind": this.widget_kind,
      "magnitude": this.magnitude,
      "choice_id": this.choice_id,
      "option_id": this.option_id,
      "is_correct": this.is_correct,
      "claim_token": this.claim_token,
      "vote_count": this.vote_count,
    };
  }
}

class Items {
  String? id;
  String? url;
  Oembed? oembed;

  Items({this.id, this.url, this.oembed});

  Items.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    url = json['url'];
    oembed =
        json['oembed'] != null ? new Oembed.fromJson(json['oembed']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['url'] = this.url;
    if (this.oembed != null) {
      data['oembed'] = this.oembed?.toJson();
    }
    return data;
  }
}

class Oembed {
  String? title;
  String? authorName;
  String? authorUrl;
  String? type;
  int? height;
  int? width;
  String? version;
  String? providerName;
  String? providerUrl;
  int? thumbnailHeight;
  int? thumbnailWidth;
  String? thumbnailUrl;
  String? html;
  String? url;

  Oembed(
      {this.title,
      this.authorName,
      this.authorUrl,
      this.type,
      this.height,
      this.width,
      this.version,
      this.providerName,
      this.providerUrl,
      this.thumbnailHeight,
      this.thumbnailWidth,
      this.thumbnailUrl,
      this.html,
      this.url});

  Oembed.fromJson(Map<String, dynamic> json) {
    title = json['title'];
    authorName = json['author_name'];
    authorUrl = json['author_url'];
    type = json['type'];
    height = json['height'];
    width = json['width'];
    version = json['version'];
    providerName = json['provider_name'];
    providerUrl = json['provider_url'];
    thumbnailHeight = json['thumbnail_height'];
    thumbnailWidth = json['thumbnail_width'];
    thumbnailUrl = json['thumbnail_url'];
    html = json['html'];
    url = json['url'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['title'] = this.title;
    data['author_name'] = this.authorName;
    data['author_url'] = this.authorUrl;
    data['type'] = this.type;
    data['height'] = this.height;
    data['width'] = this.width;
    data['version'] = this.version;
    data['provider_name'] = this.providerName;
    data['provider_url'] = this.providerUrl;
    data['thumbnail_height'] = this.thumbnailHeight;
    data['thumbnail_width'] = this.thumbnailWidth;
    data['thumbnail_url'] = this.thumbnailUrl;
    data['html'] = this.html;
    data['url'] = this.url;
    return data;
  }
}

enum WidgetState { ready, interacting, results, finished }
