class ProgramListResponse {
  int? count;
  String? next;
  String? previous;
  List<Program> results = [];

  ProgramListResponse.fromJSON(dynamic data) {
    count = data["count"];
    next = data["next"];
    previous = data["previous"];
    results = data["results"] != null
        ? List.from(data["results"]).map((e) => Program.fromJson(e)).toList()
        : [];
  }
}

class Program {
  String? url;
  String? widgetsUrl;
  String? timelineUrl;
  String? leaderboardUrl;
  String? rankUrl;
  String? clientId;
  String? applicationUrl;
  String? id;
  String? customId;
  String? title;
  String? createdAt;
  String? scheduledAt;
  String? startedAt;
  String? stoppedAt;
  String? queueOrderUrl;
  String? deleteWidgetsUrl;
  bool? widgetsEnabled;
  bool? chatEnabled;
  String? subscribeChannel;
  int? widgetCount;
  String? sendbirdChannel;
  String? streamUrl;
  String? status;
  String? syncSessionsUrl;
  String? syncChannel;
  String? startProgramUrl;
  String? stopProgramUrl;
  String? activeSessionsStatisticsUrl;
  String? statisticsChannel;
  int? currentActiveSessionCount;
  String? stickerPacksUrl;
  String? reactionPacksUrl;
  String? widgetReactionPacksUrl;
  String? updateStickerPacksUrl;
  Analytics_properties? analyticsProperties;
  String? rewardsType;
  String? reportUrl;
  String? banUrl;
  String? moderationUrl;
  String? bannedChatUsersUrl;
  String? oembedUrl;
  List<Chat_rooms>? chatRooms;
  Default_chat_room? defaultChatRoom;
  List<Leaderboards>? leaderboards;
  List<Sponsors>? sponsors;
  List<Reward_items>? rewardItems;
  String? widgetInteractionsUrlTemplate;
  String? unclaimedWidgetInteractionsUrlTemplate;

  Program(
      {this.url,
      this.widgetsUrl,
      this.timelineUrl,
      this.leaderboardUrl,
      this.rankUrl,
      this.clientId,
      this.applicationUrl,
      this.id,
      this.customId,
      this.title,
      this.createdAt,
      this.scheduledAt,
      this.startedAt,
      this.stoppedAt,
      this.queueOrderUrl,
      this.deleteWidgetsUrl,
      this.widgetsEnabled,
      this.chatEnabled,
      this.subscribeChannel,
      this.widgetCount,
      this.sendbirdChannel,
      this.streamUrl,
      this.status,
      this.syncSessionsUrl,
      this.syncChannel,
      this.startProgramUrl,
      this.stopProgramUrl,
      this.activeSessionsStatisticsUrl,
      this.statisticsChannel,
      this.currentActiveSessionCount,
      this.stickerPacksUrl,
      this.reactionPacksUrl,
      this.widgetReactionPacksUrl,
      this.updateStickerPacksUrl,
      this.analyticsProperties,
      this.rewardsType,
      this.reportUrl,
      this.banUrl,
      this.moderationUrl,
      this.bannedChatUsersUrl,
      this.oembedUrl,
      this.chatRooms,
      this.defaultChatRoom,
      this.leaderboards,
      this.sponsors,
      this.rewardItems,
      this.widgetInteractionsUrlTemplate,
      this.unclaimedWidgetInteractionsUrlTemplate});

  Program.fromJson(dynamic json) {
    url = json['url'];
    widgetsUrl = json['widgets_url'];
    timelineUrl = json['timeline_url'];
    leaderboardUrl = json['leaderboard_url'];
    rankUrl = json['rank_url'];
    clientId = json['client_id'];
    applicationUrl = json['application_url'];
    id = json['id'];
    customId = json['custom_id'];
    title = json['title'];
    createdAt = json['created_at'];
    scheduledAt = json['scheduled_at'];
    startedAt = json['started_at'];
    stoppedAt = json['stopped_at'];
    queueOrderUrl = json['queue_order_url'];
    deleteWidgetsUrl = json['delete_widgets_url'];
    widgetsEnabled = json['widgets_enabled'];
    chatEnabled = json['chat_enabled'];
    subscribeChannel = json['subscribe_channel'];
    widgetCount = json['widget_count'];
    sendbirdChannel = json['sendbird_channel'];
    streamUrl = json['stream_url'];
    status = json['status'];
    syncSessionsUrl = json['sync_sessions_url'];
    syncChannel = json['sync_channel'];
    startProgramUrl = json['start_program_url'];
    stopProgramUrl = json['stop_program_url'];
    activeSessionsStatisticsUrl = json['active_sessions_statistics_url'];
    statisticsChannel = json['statistics_channel'];
    currentActiveSessionCount = json['current_active_session_count'];
    stickerPacksUrl = json['sticker_packs_url'];
    reactionPacksUrl = json['reaction_packs_url'];
    widgetReactionPacksUrl = json['widget_reaction_packs_url'];
    updateStickerPacksUrl = json['update_sticker_packs_url'];
    analyticsProperties = json['analytics_properties'] != null
        ? Analytics_properties.fromJson(json['analytics_properties'])
        : null;
    rewardsType = json['rewards_type'];
    reportUrl = json['report_url'];
    banUrl = json['ban_url'];
    moderationUrl = json['moderation_url'];
    bannedChatUsersUrl = json['banned_chat_users_url'];
    oembedUrl = json['oembed_url'];
    if (json['chat_rooms'] != null) {
      chatRooms = [];
      json['chat_rooms'].forEach((v) {
        chatRooms?.add(Chat_rooms.fromJson(v));
      });
    }
    defaultChatRoom = json['default_chat_room'] != null
        ? Default_chat_room.fromJson(json['default_chat_room'])
        : null;
    if (json['leaderboards'] != null) {
      leaderboards = [];
      json['leaderboards'].forEach((v) {
        leaderboards?.add(Leaderboards.fromJson(v));
      });
    }
    if (json['sponsors'] != null) {
      sponsors = [];
      json['sponsors'].forEach((v) {
        sponsors?.add(Sponsors.fromJson(v));
      });
    }
    if (json['reward_items'] != null) {
      rewardItems = [];
      json['reward_items'].forEach((v) {
        rewardItems?.add(Reward_items.fromJson(v));
      });
    }
    widgetInteractionsUrlTemplate = json['widget_interactions_url_template'];
    unclaimedWidgetInteractionsUrlTemplate =
        json['unclaimed_widget_interactions_url_template'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['url'] = url;
    map['widgets_url'] = widgetsUrl;
    map['timeline_url'] = timelineUrl;
    map['leaderboard_url'] = leaderboardUrl;
    map['rank_url'] = rankUrl;
    map['client_id'] = clientId;
    map['application_url'] = applicationUrl;
    map['id'] = id;
    map['custom_id'] = customId;
    map['title'] = title;
    map['created_at'] = createdAt;
    map['scheduled_at'] = scheduledAt;
    map['started_at'] = startedAt;
    map['stopped_at'] = stoppedAt;
    map['queue_order_url'] = queueOrderUrl;
    map['delete_widgets_url'] = deleteWidgetsUrl;
    map['widgets_enabled'] = widgetsEnabled;
    map['chat_enabled'] = chatEnabled;
    map['subscribe_channel'] = subscribeChannel;
    map['widget_count'] = widgetCount;
    map['sendbird_channel'] = sendbirdChannel;
    map['stream_url'] = streamUrl;
    map['status'] = status;
    map['sync_sessions_url'] = syncSessionsUrl;
    map['sync_channel'] = syncChannel;
    map['start_program_url'] = startProgramUrl;
    map['stop_program_url'] = stopProgramUrl;
    map['active_sessions_statistics_url'] = activeSessionsStatisticsUrl;
    map['statistics_channel'] = statisticsChannel;
    map['current_active_session_count'] = currentActiveSessionCount;
    map['sticker_packs_url'] = stickerPacksUrl;
    map['reaction_packs_url'] = reactionPacksUrl;
    map['widget_reaction_packs_url'] = widgetReactionPacksUrl;
    map['update_sticker_packs_url'] = updateStickerPacksUrl;
    if (analyticsProperties != null) {
      map['analytics_properties'] = analyticsProperties?.toJson();
    }
    map['rewards_type'] = rewardsType;
    map['report_url'] = reportUrl;
    map['ban_url'] = banUrl;
    map['moderation_url'] = moderationUrl;
    map['banned_chat_users_url'] = bannedChatUsersUrl;
    map['oembed_url'] = oembedUrl;
    if (chatRooms != null) {
      map['chat_rooms'] = chatRooms?.map((v) => v.toJson()).toList();
    }
    if (defaultChatRoom != null) {
      map['default_chat_room'] = defaultChatRoom?.toJson();
    }
    if (leaderboards != null) {
      map['leaderboards'] = leaderboards?.map((v) => v.toJson()).toList();
    }
    if (sponsors != null) {
      map['sponsors'] = sponsors?.map((v) => v.toJson()).toList();
    }
    if (rewardItems != null) {
      map['reward_items'] = rewardItems?.map((v) => v.toJson()).toList();
    }
    map['widget_interactions_url_template'] = widgetInteractionsUrlTemplate;
    map['unclaimed_widget_interactions_url_template'] =
        unclaimedWidgetInteractionsUrlTemplate;
    return map;
  }
}

class Reward_items {
  String? id;
  String? url;
  String? clientId;
  String? name;

  Reward_items({this.id, this.url, this.clientId, this.name});

  Reward_items.fromJson(dynamic json) {
    id = json['id'];
    url = json['url'];
    clientId = json['client_id'];
    name = json['name'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['id'] = id;
    map['url'] = url;
    map['client_id'] = clientId;
    map['name'] = name;
    return map;
  }
}

class Sponsors {
  String? id;
  String? logoUrl;
  String? clientId;
  String? name;

  Sponsors({this.id, this.logoUrl, this.clientId, this.name});

  Sponsors.fromJson(dynamic json) {
    id = json['id'];
    logoUrl = json['logo_url'];
    clientId = json['client_id'];
    name = json['name'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['id'] = id;
    map['logo_url'] = logoUrl;
    map['client_id'] = clientId;
    map['name'] = name;
    return map;
  }
}

class Leaderboards {
  String? id;
  String? url;
  String? clientId;
  String? name;
  Reward_item? rewardItem;
  String? rewardItemId;
  bool? isLocked;
  String? entriesUrl;
  String? entryDetailUrlTemplate;

  Leaderboards(
      {this.id,
      this.url,
      this.clientId,
      this.name,
      this.rewardItem,
      this.rewardItemId,
      this.isLocked,
      this.entriesUrl,
      this.entryDetailUrlTemplate});

  Leaderboards.fromJson(dynamic json) {
    id = json['id'];
    url = json['url'];
    clientId = json['client_id'];
    name = json['name'];
    rewardItem = json['reward_item'] != null
        ? Reward_item.fromJson(json['reward_item'])
        : null;
    rewardItemId = json['reward_item_id'];
    isLocked = json['is_locked'];
    entriesUrl = json['entries_url'];
    entryDetailUrlTemplate = json['entry_detail_url_template'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['id'] = id;
    map['url'] = url;
    map['client_id'] = clientId;
    map['name'] = name;
    if (rewardItem != null) {
      map['reward_item'] = rewardItem?.toJson();
    }
    map['reward_item_id'] = rewardItemId;
    map['is_locked'] = isLocked;
    map['entries_url'] = entriesUrl;
    map['entry_detail_url_template'] = entryDetailUrlTemplate;
    return map;
  }
}

class Reward_item {
  String? id;
  String? url;
  String? clientId;
  String? name;

  Reward_item({this.id, this.url, this.clientId, this.name});

  Reward_item.fromJson(dynamic json) {
    id = json['id'];
    url = json['url'];
    clientId = json['client_id'];
    name = json['name'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['id'] = id;
    map['url'] = url;
    map['client_id'] = clientId;
    map['name'] = name;
    return map;
  }
}

class Default_chat_room {
  String? id;
  String? url;
  String? clientId;
  String? title;
  String? createdAt;
  String? contentFilter;
  String? visibility;
  Channels? channels;
  String? reportMessageUrl;
  String? reportedMessagesUrl;
  String? deleteMessageUrl;
  String? uploadUrl;
  String? membershipsUrl;
  String? mutedStatusUrlTemplate;
  String? customMessagesUrl;
  String? stickerPacksUrl;
  String? reactionPacksUrl;
  String? customData;

  Default_chat_room(
      {this.id,
      this.url,
      this.clientId,
      this.title,
      this.createdAt,
      this.contentFilter,
      this.visibility,
      this.channels,
      this.reportMessageUrl,
      this.reportedMessagesUrl,
      this.deleteMessageUrl,
      this.uploadUrl,
      this.membershipsUrl,
      this.mutedStatusUrlTemplate,
      this.customMessagesUrl,
      this.stickerPacksUrl,
      this.reactionPacksUrl,
      this.customData});

  Default_chat_room.fromJson(dynamic json) {
    id = json['id'];
    url = json['url'];
    clientId = json['client_id'];
    title = json['title'];
    createdAt = json['created_at'];
    contentFilter = json['content_filter'];
    visibility = json['visibility'];
    channels =
        json['channels'] != null ? Channels.fromJson(json['channels']) : null;
    reportMessageUrl = json['report_message_url'];
    reportedMessagesUrl = json['reported_messages_url'];
    deleteMessageUrl = json['delete_message_url'];
    uploadUrl = json['upload_url'];
    membershipsUrl = json['memberships_url'];
    mutedStatusUrlTemplate = json['muted_status_url_template'];
    customMessagesUrl = json['custom_messages_url'];
    stickerPacksUrl = json['sticker_packs_url'];
    reactionPacksUrl = json['reaction_packs_url'];
    customData = json['custom_data'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['id'] = id;
    map['url'] = url;
    map['client_id'] = clientId;
    map['title'] = title;
    map['created_at'] = createdAt;
    map['content_filter'] = contentFilter;
    map['visibility'] = visibility;
    if (channels != null) {
      map['channels'] = channels?.toJson();
    }
    map['report_message_url'] = reportMessageUrl;
    map['reported_messages_url'] = reportedMessagesUrl;
    map['delete_message_url'] = deleteMessageUrl;
    map['upload_url'] = uploadUrl;
    map['memberships_url'] = membershipsUrl;
    map['muted_status_url_template'] = mutedStatusUrlTemplate;
    map['custom_messages_url'] = customMessagesUrl;
    map['sticker_packs_url'] = stickerPacksUrl;
    map['reaction_packs_url'] = reactionPacksUrl;
    map['custom_data'] = customData;
    return map;
  }
}

class Channels {
  Chat? chat;
  Reactions? reactions;
  Control? control;

  Channels({this.chat, this.reactions, this.control});

  Channels.fromJson(dynamic json) {
    chat = json['chat'] != null ? Chat.fromJson(json['chat']) : null;
    reactions = json['reactions'] != null
        ? Reactions.fromJson(json['reactions'])
        : null;
    control =
        json['control'] != null ? Control.fromJson(json['control']) : null;
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    if (chat != null) {
      map['chat'] = chat?.toJson();
    }
    if (reactions != null) {
      map['reactions'] = reactions?.toJson();
    }
    if (control != null) {
      map['control'] = control?.toJson();
    }
    return map;
  }
}

class Control {
  String? pubnub;

  Control({this.pubnub});

  Control.fromJson(dynamic json) {
    pubnub = json['pubnub'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['pubnub'] = pubnub;
    return map;
  }
}

class Reactions {
  String? pubnub;

  Reactions({this.pubnub});

  Reactions.fromJson(dynamic json) {
    pubnub = json['pubnub'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['pubnub'] = pubnub;
    return map;
  }
}

class Chat {
  dynamic? sendbird;
  String? pubnub;

  Chat({this.sendbird, this.pubnub});

  Chat.fromJson(dynamic json) {
    sendbird = json['sendbird'];
    pubnub = json['pubnub'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['sendbird'] = sendbird;
    map['pubnub'] = pubnub;
    return map;
  }
}

class Chat_rooms {
  String? id;
  String? url;
  String? clientId;
  String? title;
  String? createdAt;
  String? contentFilter;
  String? visibility;
  Channels? channels;
  String? reportMessageUrl;
  String? reportedMessagesUrl;
  String? deleteMessageUrl;
  String? uploadUrl;
  String? membershipsUrl;
  String? mutedStatusUrlTemplate;
  String? customMessagesUrl;
  String? stickerPacksUrl;
  String? reactionPacksUrl;
  dynamic? customData;

  Chat_rooms(
      {this.id,
      this.url,
      this.clientId,
      this.title,
      this.createdAt,
      this.contentFilter,
      this.visibility,
      this.channels,
      this.reportMessageUrl,
      this.reportedMessagesUrl,
      this.deleteMessageUrl,
      this.uploadUrl,
      this.membershipsUrl,
      this.mutedStatusUrlTemplate,
      this.customMessagesUrl,
      this.stickerPacksUrl,
      this.reactionPacksUrl,
      this.customData});

  Chat_rooms.fromJson(dynamic json) {
    id = json['id'];
    url = json['url'];
    clientId = json['client_id'];
    title = json['title'];
    createdAt = json['created_at'];
    contentFilter = json['content_filter'];
    visibility = json['visibility'];
    channels =
        json['channels'] != null ? Channels.fromJson(json['channels']) : null;
    reportMessageUrl = json['report_message_url'];
    reportedMessagesUrl = json['reported_messages_url'];
    deleteMessageUrl = json['delete_message_url'];
    uploadUrl = json['upload_url'];
    membershipsUrl = json['memberships_url'];
    mutedStatusUrlTemplate = json['muted_status_url_template'];
    customMessagesUrl = json['custom_messages_url'];
    stickerPacksUrl = json['sticker_packs_url'];
    reactionPacksUrl = json['reaction_packs_url'];
    customData = json['custom_data'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['id'] = id;
    map['url'] = url;
    map['client_id'] = clientId;
    map['title'] = title;
    map['created_at'] = createdAt;
    map['content_filter'] = contentFilter;
    map['visibility'] = visibility;
    if (channels != null) {
      map['channels'] = channels?.toJson();
    }
    map['report_message_url'] = reportMessageUrl;
    map['reported_messages_url'] = reportedMessagesUrl;
    map['delete_message_url'] = deleteMessageUrl;
    map['upload_url'] = uploadUrl;
    map['memberships_url'] = membershipsUrl;
    map['muted_status_url_template'] = mutedStatusUrlTemplate;
    map['custom_messages_url'] = customMessagesUrl;
    map['sticker_packs_url'] = stickerPacksUrl;
    map['reaction_packs_url'] = reactionPacksUrl;
    map['custom_data'] = customData;
    return map;
  }
}

class Analytics_properties {
  String? programID;
  String? programTitle;
  String? customProgramID;

  Analytics_properties(
      {this.programID, this.programTitle, this.customProgramID});

  Analytics_properties.fromJson(dynamic json) {
    programID = json['Program ID'];
    programTitle = json['Program Title'];
    customProgramID = json['Custom Program ID'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['Program ID'] = programID;
    map['Program Title'] = programTitle;
    map['Custom Program ID'] = customProgramID;
    return map;
  }
}
