import 'package:livelike_flutter_sdk/livelike_flutter_sdk.dart';

class TimeLineResponse {
  int? count;
  String? next;
  String? previous;
  String? widgetInteractionsUrlTemplate;
  List<LiveLikeWidget> results = [];

  TimeLineResponse.fromJson(Map<String, dynamic> json) {
    count = json['count'];
    next = json['next'];
    previous = json['previous'];
    widgetInteractionsUrlTemplate = json['widget_interactions_url_template'];
    if (json['results'] != null) {
      json['results'].forEach((v) {
        results.add(new LiveLikeWidget.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['count'] = this.count;
    data['next'] = this.next;
    data['previous'] = this.previous;
    data['widget_interactions_url_template'] =
        this.widgetInteractionsUrlTemplate;
    data['results'] = this.results.map((v) => v.toJson()).toList();
    return data;
  }
}
