import 'dart:convert';

import 'package:http/http.dart' as http;
import 'package:livelike_flutter_sdk/src/model/program.dart';

class ProgramRepository {
  final _baseUrl = "https://cf-blast.livelikecdn.com/api/v1/programs";

  Future<ProgramListResponse> getListofPrograms(String clientId,
      {String? url}) async {
    final response =
        await http.get(Uri.parse(url ?? "$_baseUrl/?client_id=$clientId"));
    return ProgramListResponse.fromJSON(jsonDecode(response.body));
  }

  Future<Program> getProgramDetails(String programId) async {
    final response = await http.get(Uri.parse("$_baseUrl/$programId"));
    return Program.fromJson(jsonDecode(response.body));
  }
}
