import 'dart:convert';

import 'package:http/http.dart' as http;
import 'package:livelike_flutter_sdk/src/constants.dart';
import 'package:livelike_flutter_sdk/src/model/user_profile.dart';

class UserRepository {
  Future<UserProfile> getUserProfile(
      String clientId, String accessToken) async {
    final response = await http.get(
      Uri.parse("${baseUrl}applications/$clientId/profile/"),
      headers: {"Authorization": "Bearer $accessToken"},
    );
    return UserProfile.fromJson(jsonDecode(response.body));
  }
}
